package org.integrade.asct.ws;

import javax.ws.rs.DELETE;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.core.UriInfo;

import org.integrade.asct.ws.datatypes.Application;

import clusterManagement.ApplicationNotFoundException;

@Path("/application/{application_id:.+}")
public class WSIntegradeApplication {

	private WSApplicationFacade controller = WSApplicationFacade.getInstance();

	@GET
	public Response getIntegradeApplication(@PathParam("application_id") String id,
			@Context UriInfo uriInfo) {

		Response response = null;

		try {
			Application application = controller.getApplicationById(id);
			response = Response.ok(application).build();
		} catch (ApplicationNotFoundException anfe) {
			response = Response.status(Status.NOT_FOUND).build();
		}
		catch (Exception e) {
			e.printStackTrace();
			response = Response.status(Status.INTERNAL_SERVER_ERROR).build();
		}

		return response;
	}

	@DELETE
	public Response unregisterIntegradeApplication(@PathParam("application_id") String id,
			@Context UriInfo uriInfo) {
		Response response = null;

		try {
			Application application = controller.getApplicationById(id);
			for (String binaryName : application.getBinaryIds()) {
				controller.deleteBinary(application.getBasePath(), application.getApplicationName(), binaryName);
			}
			controller.unregisterApplication(application.getBasePath(),
					application.getApplicationName());

			response = Response.ok().build();
		} catch (ApplicationNotFoundException anfe) {
			// anfe.printStackTrace();
			response = Response.status(Status.INTERNAL_SERVER_ERROR).build();
		} catch (Exception e) {
			e.printStackTrace();
			response = Response.status(Status.INTERNAL_SERVER_ERROR).build();
		}

		return response;
	}
}
