package org.integrade.asct.ws;

import java.util.List;

import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.core.UriBuilder;
import javax.ws.rs.core.UriInfo;

import org.integrade.asct.ws.datatypes.Application;
import org.integrade.asct.ws.datatypes.Applications;

import clusterManagement.DirectoryCreationException;
import clusterManagement.InvalidPathNameException;

@Path("/applications")
public class WSIntegradeApplications {

	private WSApplicationFacade controller = WSApplicationFacade.getInstance();

	@GET
	public Response getIntegradeApplication(@QueryParam("query") String query,  @Context UriInfo uriInfo) {

		Response response = null;

		try {
			if (query == null)
				query = "";
			List<Application> listApplications = controller.getApplicationList(query);
			Applications applications = new Applications();
			applications.getApplication().addAll(listApplications);
			response = Response.ok(applications).build();
		}
		catch (Exception e) {
			e.printStackTrace();
			response = Response.status(Status.INTERNAL_SERVER_ERROR).build();
		}

		return response;
	}
	
	@POST
	public Response createIntegradeApplication(Application appl, @Context UriInfo uriInfo) {

		Response response = null;

		try {
			controller.createDirectory(appl.getBasePath());
			
			controller.registerApplication(appl.getBasePath(), appl.getApplicationName());

			Application appl1 = new Application(controller.getApplicationDescription(appl.getApplicationName(), appl.getBasePath()));
			UriBuilder uriB = uriInfo.getBaseUriBuilder();
			uriB.path(WSIntegradeApplication.class);
			response = Response.created(uriB.build(appl1.getId())).build();
		} 
		
		catch (DirectoryCreationException e) {
			System.out.println("[Warning] Problem creating directory.");
			response = Response.status(Status.INTERNAL_SERVER_ERROR).build();

		} 
		
		catch (InvalidPathNameException e) {
			e.printStackTrace();
			System.out.println("[Warning] Invalid pathname.");
			response = Response.status(Status.INTERNAL_SERVER_ERROR).build();
		}
		
		catch (Exception e) {
			e.printStackTrace();
			response = Response.status(Status.INTERNAL_SERVER_ERROR).build();
		}

		return response;	
	}
}
