package org.integrade.asct.ws;

import javax.ws.rs.DELETE;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.core.UriInfo;

import org.integrade.asct.ws.datatypes.Execution;

import asct.shared.ApplicationState;

@Path("/execution/{execution_id:.+}")
public class WSIntegradeExecution {

	private WSApplicationFacade controller = WSApplicationFacade.getInstance();

	@GET
	public Response getExecutionStatus(@PathParam("execution_id") String id,
			@Context UriInfo uriInfo) {

		Response response = null;

		try {
			WSExecutionListener listener = WSExecutionListener.getInstance();
			ApplicationState status = listener.getStatus(id);
			if (status == null){
				response = Response.status(Status.NOT_FOUND).build();
			}
			else{
				Execution execution = controller.getExecutionDetails(id);
			    execution.setStatus(status.toString());
			    response = Response.ok(execution).build();
			}
		} catch (Exception e) {
			e.printStackTrace();
			response = Response.status(Status.INTERNAL_SERVER_ERROR).build();
		}
		return response;
	}

	@DELETE
	public Response killApplication(@PathParam("execution_id") String id,
			@Context UriInfo uriInfo) {
		Response response = null;

		try {
			if (controller.killApplicationExecution(id))
				response = Response.ok().build();
			else
				response = Response.status(Status.NOT_FOUND).build();
			
		} catch (Exception e) {
			e.printStackTrace();
			response = Response.status(Status.INTERNAL_SERVER_ERROR).build();
		}
		
		return response;
	}
}
