package org.integrade.asct.ws;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.core.UriInfo;

import org.integrade.asct.ws.datatypes.Execution;
import org.integrade.asct.ws.datatypes.ExecutionFile;

import asct.shared.ApplicationState;

@Path("/execution/{execution_id:.+}/result")
public class WSIntegradeExecutionResult {

	private WSApplicationFacade controller = WSApplicationFacade.getInstance();

	@GET
	public Response unregisterIntegradeApplication(@PathParam("execution_id") String execReqId,
			@Context UriInfo uriInfo) {

		Response response = null;

		try {
			WSExecutionListener listener = WSExecutionListener.getInstance();
			ApplicationState status = listener.getStatus(execReqId);
			if (status == null){
				response = Response.status(Status.NOT_FOUND).build();
			}
			
			else{
			    controller.getApplicationResults(execReqId, null);

			    Execution exec = new Execution();
			    File execPath = new File(System.getProperty("user.home") 
			    	+ File.separator + "output"
					+ File.separator + execReqId);

			    for (File nodes : execPath.listFiles()) {
			    	for (File f : nodes.listFiles()) {
			    		ExecutionFile ef = new ExecutionFile();
			    		ef.setFileName(f.getName());
			    		ef.setFile(readFile(f));
			    		exec.getOutputFiles().add(ef);
			    	}
			    }

			    exec.setArguments(null);
			    exec.setConstraints(null);
			    exec.setPreferences(null);
			    exec.setStoreStderr(null);
			    exec.setStoreStdout(null);
			    exec.setForceDifferentNodes(null);
			    exec.setApplicationType(null);
			    exec.setInputFiles(null);
			    exec.setNumberOfCopies(null);
			    exec.setNumberOfTasks(null);
			
			    response = Response.ok(exec).build();
			}
			
		} catch (Exception e) {
			e.printStackTrace();
			response = Response.status(Status.INTERNAL_SERVER_ERROR).build();
		}

		return response;
	}

	private byte[] readFile(File f) throws IOException {
		InputStream in = new FileInputStream(f);
		StringBuffer sb = new StringBuffer();
		int c;
		while ((c = in.read()) >= 0) {
			sb.append((char) c);
		}
		return sb.toString().getBytes();
	}
}
