package org.integrade.asct.ws.datatypes;

import javax.xml.bind.annotation.*;

import dataTypes.ApplicationDescription;


@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "id",
    "basePath",
    "applicationName",
    "numberOfBinaries",
    "binaryIds"
})
@XmlRootElement(name = "application")
public class Application {
	
	private static String NL = System.getProperty("line.separator");

	@XmlElement(required = true)
	private String id = "";
	private String basePath = "";
	private String applicationName = "";
	private String numberOfBinaries = "";
	@XmlElementWrapper(name="binaries")
	@XmlElement(name="binary")
	private String[] binaryIds;

	public Application() {
	}

	public Application(ApplicationDescription appDesc) {
		this(appDesc.appId, appDesc.basePath, 
			 appDesc.applicationName, appDesc.numberOfBinaries, appDesc.binaryIds);
	}

	public Application(String id, String basePath, String applicationName,
			String numberOfBinaries, String[] binaryIds) {
		this.id = id;
		this.basePath = basePath;
		this.applicationName = applicationName;
		this.numberOfBinaries = numberOfBinaries;
		this.binaryIds = binaryIds;
	}

	public String getBasePath() {
		return basePath;
	}

	public void setBasePath(String basePath) {
		this.basePath = basePath;
	}

	public String getApplicationName() {
		return applicationName;
	}

	public void setApplicationName(String applicationName) {
		this.applicationName = applicationName;
	}

	public String getNumberOfBinaries() {
		return numberOfBinaries;
	}

	public void setNumberOfBinaries(String numberOfBinaries) {
		this.numberOfBinaries = numberOfBinaries;
	}

	
	public String[] getBinaryIds() {
		return binaryIds;
	}

	public void setBinaryIds(String[] binaryIds) {
		this.binaryIds = binaryIds;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String toString() {
		StringBuffer str = new StringBuffer();
		str.append("id=").append(id).append(NL);
		str.append("basePath=").append(basePath).append(NL);
		str.append("applicationName=").append(applicationName).append(NL);
		str.append("numberOfBinaries=").append(numberOfBinaries).append(NL);
		
		for(int i = 0; i < binaryIds.length; i++) {
			str.append("binaryIds[").append(i).append("]=").append(binaryIds[i]).append(NL);
		}
		return str.toString();
	}
}
