package org.integrade.asct.ws.datatypes;

import javax.xml.bind.annotation.*;

import dataTypes.ApplicationDescription;


@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "applicationId",
    "basePath",
    "applicationName",
    "architecture",
    "file"
})
@XmlRootElement(name = "binary")
public class Binary {

	@XmlElement(required = true)
	private String applicationId = "";
	private String basePath = "";
	private String applicationName = "";
	private String architecture = "";
	private byte[] file;

	public Binary() {
	}

	public Binary(ApplicationDescription appDesc, int binaryIndex) {
		this(appDesc.appId, appDesc.basePath, appDesc.applicationName, 
			 appDesc.binaryIds[binaryIndex]);
	}

	public Binary(String id, String basePath, String applicationName, 
			      String architecture) {
		this.applicationId = id;
		this.basePath = basePath;
		this.applicationName = applicationName;
		this.architecture = architecture;
	}

	public String getBasePath() {
		return basePath;
	}

	public void setBasePath(String basePath) {
		this.basePath = basePath;
	}

	public String getApplicationName() {
		return applicationName;
	}

	public void setApplicationName(String applicationName) {
		this.applicationName = applicationName;
	}

	public String getArchitecture() {
		return architecture;
	}

	public void setArchitecture(String architecture) {
		this.architecture = architecture;
	}

	public String getApplicationId() {
		return applicationId;
	}

	public void setApplicationId(String applicationId) {
		this.applicationId = applicationId;
	}
	
	public void setFile(byte[] file) {
		this.file = file;
	}
	
	public byte[] getFile() {
		return file;
	}
}
