package org.integrade.asct.ws.datatypes;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType (propOrder = {
    "arguments",
	"inputFileNames",
	"outputFileNames" 
})
@XmlRootElement(name = "parametricCopy")
public class ParametricCopy {

	@XmlElement(required = true)
	private String arguments;
	@XmlElement( name="executionFile" )
    @XmlElementWrapper( name="inputFileNames" )
	private List<ExecutionFile> inputFileNames = new ArrayList<ExecutionFile>(); 
	@XmlElement( name="executionFile" )
    @XmlElementWrapper( name="outputFileNames" )
	private List<ExecutionFile> outputFileNames = new ArrayList<ExecutionFile>();

    public ParametricCopy (){
    	
    }

    public ParametricCopy (String arguments, List<ExecutionFile> inputFileNames,
    		               List<ExecutionFile> outputFileNames){
    	this.setArguments(arguments);
    	this.inputFileNames = inputFileNames;
    	this.outputFileNames = outputFileNames;
    }
    
	public List<ExecutionFile> getInputFileNames() {
		return inputFileNames;
	}

	public void setInputFileNames(List<ExecutionFile> inputFileNames) {
		this.inputFileNames = inputFileNames;
	}

	public List<ExecutionFile> getOutputFileNames() {
		return outputFileNames;
	}

	public void setOutputFileNames(List<ExecutionFile> outputFileNames) {
		this.outputFileNames = outputFileNames;
	}

	public String getArguments() {
		return arguments;
	}

	public void setArguments(String arguments) {
		this.arguments = arguments;
	}

}