package org.integrade.asct.ws;

import org.apache.cxf.jaxrs.JAXRSServerFactoryBean;

public class AsctWSTestServer implements Runnable {

	private static boolean running = false;

	public static void start() throws InterruptedException {
		new Thread(new AsctWSTestServer()).start();
		while (!running) {
			Thread.sleep(1);
		}

	}

	public static void stop() {
		running = false;
	}

	public void run() {
		JAXRSServerFactoryBean sf = new JAXRSServerFactoryBean();
		sf.setResourceClasses(WSIntegradeApplication.class, WSIntegradeApplications.class,
				WSIntegradeApplicationBinaries.class, WSIntegradeExecution.class,
				WSIntegradeExecutions.class, WSIntegradeExecutionResult.class);
		sf.setAddress(System.getProperty("asct_ws.url","http://localhost:8080/"));
		sf.create();
		System.out.println("Starting server...");
		running = true;
		
		if (System.getProperty("DEBUG", "false").equalsIgnoreCase("true")) {
			System.out.println("classpath=" + System.getProperty("java.class.path"));
			System.out.println("lib.path=" + System.getProperty("java.library.path"));
		}

		while (running) {
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		System.out.println("Stopping server...");

	}

	public static void main(String[] args) throws InterruptedException {
		AsctWSTestServer.start();
	}

}
