/*
 * @(#) AbstractGridApplication.java 1.0 May 11, 2005
 *
 * CopyLeft IME/USP
 */
package asct.shared;

import java.util.Vector;

import asct.core.submission.ExecutionRequest;
import dataTypes.ApplicationDescription;


/**
 * An abstract Grid Application.
 * @version 1.0 May 11, 2005
 * @author Eduardo Guerra
 *
 */
public abstract class AbstractGridApplication {
	
	// ASCT-WS attributes 
	private String constraints;
	private String preferences;
	private String applicationType;
	private String arguments;
	//
	
	private Vector<ExecutionRequest> executionRequests;

	/** Contains information about the application */
	private ApplicationDescription description;
	
	/**
	 * Constructor
	 */
	public AbstractGridApplication(String name, String remoteApplicationPath) {
		description = new ApplicationDescription();
		description.applicationName = name;
		description.basePath = remoteApplicationPath;
		executionRequests = new Vector<ExecutionRequest>();
	}

	/**
	 * 
	 * */
	public String getName() {
		return description.applicationName;
	}
	
	/**
	 * 
	 * */
	public String getBasePath() {
		return description.basePath;
	}
	
	public String[] getBinaryIds() {
		return this.description.binaryIds;
	}

	public ApplicationDescription getApplicationDescription (){
		return this.description;
	}
	
	public Vector<ExecutionRequest> getExecutionRequests (){
		return this.executionRequests;
	}
	
	/**
	 * @param description The description to set.
	 */
	public final void setDescription(ApplicationDescription description) {
		this.description = description;
	}

	// ASCT-WS methods
	
	public String getConstraints (){
		return this.constraints;
	}

	public void setConstraints (String constraints){
		this.constraints = constraints;
	}

	public String getPreferences (){
		return this.preferences;
	}

	public void setPreferences (String preferences){
		this.preferences = preferences;
	}
	
	public String getArguments (){
		return this.arguments;
	}

	public void setArguments (String arguments){
		this.arguments = arguments;
	}
	
	public String getApplicationType (){
		return this.applicationType;
	}

	public void setApplicationType (String applicationType){
		this.applicationType = applicationType;
	}



}
