package asct.shared;
/**
 ParametricCopyHolder - Holds information regarding one instance of a parametric
 execution request.
 
 @author Andrei Goldchleger
 @date February/2004
 
 */
public class ParametricCopyHolder{
	
	//Fields------------------------------------------------------------------
	private int copyId_;     /**< Id of this instance. Used only for labeling in the GUI */
	private String args_;    /**< Arguments that will be passed to this application instance */
	private String [] inputFiles_;/**< Files needed by this application instance */
	private String [] outputFiles_;/**< Files generated by this application instance */
	
	//Costructor--------------------------------------------------------------
	
	/**
	 Creates a new ParametricCopyHolder.
	 
	 @param copyId - Id of this instance. Used only for labeling in the GUI
	 @param args - Arguments that will be passed to this application in stance
	 @param inputFiles - Files needed by this application instance
	 @param outputFiles - Files generated by this application instance
	 */
	public ParametricCopyHolder(int copyId, String args, String [] inputFiles, String [] outputFiles){
		
		copyId_ = copyId;
		args_ = args;
		inputFiles_ = inputFiles;
		outputFiles_ = outputFiles;
		
	}
	
	public ParametricCopyHolder(){}
	
	//-------------------------------------------------------------------------
	/**
	 Overrides java.lang.Object method. Used to determine what is displayed by
	 the JList that holds this object.
	 */
	public String toString(){ return (new Integer(copyId_)).toString(); }
	
	
	public int copyId() { 
		return copyId_; 
	}
	
	public String getArguments() { 
		return args_; 
	}
	
	public String [] getInputFiles() { 
		return inputFiles_; 
	}

	public void setInputFiles(String [] inputFiles) {
		inputFiles_ = inputFiles; 
	}
	
	public String [] getOutputFiles() { 
		return outputFiles_; 
	}

	public void setOutputFiles(String [] outputFiles) {
		outputFiles_ = outputFiles; 
	}
	
	public void setCopyId(int copyId) {
		copyId_ = copyId; 
	}
	
	public void setArguments(String args) {
		args_ = args; 
	}
}
