/*
 * Created on 07/12/2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package moca.core.proxy.communication.async;

import moca.core.proxy.ProxyException;
import moca.core.proxy.communication.ClientCommunication;
import moca.core.proxy.communication.CommunicationProtocol;
import moca.protocol.eci.server.SubscriptionListener;
import moca.util.eci.ECIConstants;
import moca.util.eci.Subscription;


/**
 * When an subscription is received it is passed to the application proxy implementation
 * @author hana
 *
 */
public class ClientSubscriptionListener implements SubscriptionListener {

	protected ClientCommunication clientCommunic;
	
	/**
	 * 
	 */
	public ClientSubscriptionListener(ClientCommunication cc) {
		clientCommunic = cc;
	}

	/* (non-Javadoc)
	 * @see moca.protocol.pubsub.eventprovider.SubscriptionListener#onReceiveSubscription(moca.protocol.pubsub.Subscription)
	 */
	public void onReceiveSubscription(Subscription sub) {
		TreatSubscription thread = new TreatSubscription(sub);
		thread.start();
	}

	private class TreatSubscription extends Thread{
		Subscription subscription = null;
		
		TreatSubscription(Subscription sub){
			subscription = sub;			
		}
		
		public void run(){
			CommunicationProtocol cm = null;
			Integer prot = subscription.getCommunicationProtocol();

			try {
				//	 Enviar a msg para a aplicao, junto com o protocolo
				if (prot.equals(ECIConstants.TCP))
					cm = new CommunicationProtocol(CommunicationProtocol.TCP,CommunicationProtocol.EVENT);
				else
					cm = new CommunicationProtocol(CommunicationProtocol.UDP,CommunicationProtocol.EVENT);
			} catch (ProxyException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}			
			cm.setAddress(subscription.getSubscriberAddress());
			
			//TODO: TRATAR A COMUNICAAO -- OU SEJA FAZER O SUBSCRIBE AO SERVIDOR
			// SE FOR UM NOVO TOPICO  -- 
			//TB interceptar o unsubscribe, para se desregistrar no servidor, quando
			// no houver mais clientes interessados 
			
			clientCommunic.notifySubscriptionToApp(subscription,cm);

		}
	}
}
