package moca.core.proxy.state.filter;

/**
 * Operador lgico AND. Recebe dois objetos do tipo BooleanValue
 * e retorna true se ambos valoram para true e falso caso contrario
 * @author hana
 */
public class AndOperator extends BinaryOperator implements BooleanValue {
	/**
	 * Construtor
	 * @param bv1 operando 1
	 * @param bv2 operando 2
	 */
	public AndOperator(BooleanValue bv1, BooleanValue bv2) {
		super(bv1, bv2);
	}
	/**
	* Faz a avaliao dos parametros e compara o resultado
	* @param metapack informacoes para avaliao
	*/
	public Object evaluate(MetaPackage metapack) {
		boolean b1 = ((BooleanValue) this.val1).getBooleanValue(metapack);
		boolean b2 = ((BooleanValue) this.val2).getBooleanValue(metapack);
		return new Boolean(b1 && b2);
	}

	/**
	 * Valor segundo a interface BooleanValue
	 * @param metapack informacoes para avaliao
	 */
	public boolean getBooleanValue(MetaPackage metapack) {
		Boolean b = (Boolean) this.evaluate(metapack);
		return b.booleanValue();
	}
	/**
	 * Converte a expressao para uma string
	 * @return expressao na forma de string
	 */
	public String toString() {
		return "(" + this.val1 + " and " + this.val2 + ")";
	}
}