package moca.core.proxy.state.filter;

/**
 * Retorna o valor de um campo. Este valor  fornecido por MetaPackage
 * @author hana
 */
public class FieldValueOperator extends UnaryOperator implements StringValue {
	public FieldValueOperator(StringValue val) {
		super(val);
	}
	public Object evaluate(MetaPackage pack) {
		//recupera o nome do campo
		String fieldName = ((StringValue) this.val).getStringValue(pack);
		//recupera o valor de campo e retorne
		return pack.getAttributeValue(fieldName);
	}
	/**
	* Retorna o valor como string de acordo com a interface StringValue
	*/
	public String getStringValue(MetaPackage pack) {
		return (String) this.evaluate(pack);
	}
	/**
	 * Converte a expressao para uma string
	 * @return expressao na forma de string
	 */
	public String toString() {
		return "(${" + this.val + "})";
	}

}
